// 013 u_c_search_pathes
// 03 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

// -- loads the search path from a .DOF

(*$r+*)

unit u_c_search_pathes;
  interface
    uses Classes, u_c_basic_object;

    type c_search_pathes= class(c_basic_object)
                              public
                                m_c_path_list: tStringList;

                                Constructor create_search_pathes(p_name: String); Virtual;
                                procedure read_path_from_dof(p_dof_name: String);
                                procedure add_search_path(p_search_path: String);
                                procedure insert_search_path(p_index: Integer; p_search_path: String);
                                function f_search_path(p_path_index: Integer): String;
                                function f_search_path_count: Integer;
                                Destructor Destroy; Override;
                            end;

  implementation
    uses IniFiles, SysUtils
        , u_c_display, u_c_file_name;

    // -- c_search_pathes

    Constructor c_search_pathes.create_search_pathes(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_path_list:= tStringList.Create;
      end; // create_search_pathes

    procedure c_search_pathes.read_path_from_dof(p_dof_name: String);
      var l_c_ini_file: tIniFile;
          l_c_directories: tStringList;
          l_search: String;
          l_index: Integer;
          l_path: String;
      begin
        display('load '+ p_dof_name);
        l_c_ini_file:= tIniFile.Create(p_dof_name);
        l_c_directories:= tStringList.Create;
        l_c_ini_file.ReadSectionValues('Directories', l_c_directories);
        l_search:= l_c_directories.Values['SearchPath'];
        display(' search: >'+ l_search+ '<');

        // | SearchPath=C:\prog\helper\units;C:\prog\helper\classes
        l_path:= '';
        for l_index:= 1 to Length(l_search) do
        begin
          if l_search[l_index]= ';'
            then begin
                m_c_path_list.Add(l_path);
                l_path:= '';
              end
            else l_path:= l_path+ l_search[l_index];
        end;

        // -- the last path
        m_c_path_list.Add(l_path);
      end; // read_path_from_dof

    procedure c_search_pathes.add_search_path(p_search_path: String);
      begin
        m_c_path_list.Add(p_search_path);
      end; // add_search_path

    procedure c_search_pathes.insert_search_path(p_index: Integer; p_search_path: String);
      begin
        m_c_path_list.Insert(p_index, p_search_path);
      end; // insert_search_path

    function c_search_pathes.f_search_path(p_path_index: Integer): String;
      begin
        Result:= m_c_path_list[p_path_index];
      end; // f_search_path

    function c_search_pathes.f_search_path_count: Integer;
      begin
        Result:= m_c_path_list.Count;
      end; // f_search_path_count

    Destructor c_search_pathes.Destroy;
      begin
        m_c_path_list.Free;
        Inherited;
      end; // Destroy

    begin // u_c_search_pathes
    end. // u_c_search_pathes



