// 013 u_find_uses
// 03 jan 2002

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_find_uses;
  interface
    uses Classes;

    function f_c_find_uses(p_path, p_file_name: String): tStringList;

  implementation
    uses SysUtils, Forms
      , u_types_constants
      , u_c_display
      , u_c_file_name
      , u_c_search_pathes
      , u_c_uses_list
      , u_c_path_segments
      , u_c_find_uses
      ;

    var g_file_count: Integer= 0;
        g_c_uses_list: c_uses_list= Nil;
        g_c_search_pathes: c_search_pathes= Nil;

        g_c_project_path_segments: c_path_segments= nil;

    procedure initialize_search_pathes(p_path, p_name: String);
      var l_index: Integer;
      begin
        if Not Assigned(g_c_search_pathes)
          then begin
              display('Load search');
              g_c_search_pathes:= c_search_pathes.create_search_pathes('search');
              // -- place the path of the DPR in this list
              g_c_search_pathes.insert_search_path(0, p_path);

              g_c_search_pathes.read_path_from_dof(p_path+ ChangeFileExt(p_name, '.DOF'));

              if f_is_dpr(p_name)
                then begin
                    // -- also change all relative pathes of .DOF to absolute paths
                    // --   this will mainly simplify the copying later
                    with g_c_search_pathes, m_c_path_list do
                      for l_index:= 1 to Count- 1 do
                        m_c_path_list[l_index]:= g_c_project_path_segments.f_absolute_path(m_c_path_list[l_index]);
                  end;

              display('search_pathes');
              display_strings(g_c_search_pathes.m_c_path_list);
            end;
      end; // initialize_search_pathes

    procedure handle_one_file(p_name: String);

      procedure handle_file(p_name: String; p_level: Integer);
        // -- recursive

        procedure find_uses_of_uses;
          var l_index: integer;
              l_name: String;
              l_path_index: Integer;
          begin
            with g_c_uses_list do
              for l_index:= 0 to f_use_count- 1 do
                with f_c_use(l_index) do
                  if not m_analyzed
                    then begin
                        l_name:= ExtractFilePath(p_name)+ m_name+ '.pas';

                        if FileExists(l_name)
                          then begin
                              Inc(m_count);
                              handle_file(l_name, p_level+ 1);
                            end
                          else begin
                              If Assigned(g_c_search_pathes)
                                then
                                  for l_path_index:= 0 to g_c_search_pathes.f_search_path_count- 1 do
                                  begin
                                    l_name:= g_c_search_pathes.f_search_path(l_path_index)+ '\'+ m_name+ '.pas';
                                    if FileExists(l_name)
                                      then begin
                                          Inc(m_count);
                                          handle_file(l_name, p_level+ 1);
                                          Break;
                                        end;
                                  end; // -- for all the search pathes

                              if not m_analyzed
                                then begin
                                    display_bug_stop('could not find '+ m_name+ '< '+ k_return_line_feed
                                       + '  in '+ ExtractFilePath(p_name)+ k_return_line_feed
                                       + ' or_in '+ g_c_search_pathes.m_c_path_list.Text);
                                  end;
                            end;
                      end; // an inner uses
          end; // find_uses_of_uses

        begin // handle_file
          clear_display;
          display_line;
          display('> handle '+ p_name);

          with c_find_uses.create_find_uses('dir', p_name) do
          begin
            if f_is_custom_unit(p_name) or f_is_dpr(p_name)
              then parse(p_name, p_level, g_c_uses_list);

            Free;
          end; // with c_find_uses

          // -- now find the uses of the uses
          find_uses_of_uses;

          Inc(g_file_count);

          display('< '+ IntToStr(g_file_count));
        end; // handle_file

      begin // handle_one_file
        handle_file(p_name, 0);
      end; // handle_one_file

    function f_c_find_uses(p_path, p_file_name: String): tStringList;
      var l_absolute_path: String;
          l_file_name: String;
          l_index: Integer;
      begin
        l_absolute_path:= p_path;
        l_file_name:= p_file_name;

        display_line;

        if Copy(l_absolute_path, 2, 1)<> ':'
          then begin
              l_absolute_path:= ExtractFilePath(Application.ExeName)+ l_absolute_path;

              display(l_absolute_path);
              l_absolute_path:= f_remove_middle_dot_dot(l_absolute_path);
              display_line;
              display(l_absolute_path);
            end;  

        if f_is_dpr(l_file_name)
          then begin
              g_c_project_path_segments:= c_path_segments.create_path_segments('dpr', l_absolute_path);

              display('path segment of '+ l_file_name);
              display_strings(g_c_project_path_segments.m_c_segments);
            end;

        g_c_uses_list:= c_uses_list.create_uses_list('uses_list', '');

        initialize_search_pathes(l_absolute_path, l_file_name);

        // -- add here additional search pathes
        g_c_search_pathes.add_search_path('c:\programs\');

        handle_one_file(l_absolute_path+ l_file_name);

        g_c_uses_list.display_uses_list;

        Result:= tStringList.Create;
        Result.Assign(g_c_uses_list.m_c_uses_list);
      end; // f_c_find_uses
  end.
